freeslot(
"MT_WOLFBULLET",
"MT_WOLFCAMERA"
)

mobjinfo[MT_WOLFCAMERA] = {
	spawnstate = S_INVISIBLE,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

local function WolfensteinCameraObj(player, mo)
	if not (player.mo) then return end
	
	local z
	if (player.mo.eflags & MFE_VERTICALFLIP)
		z = (player.mo.z + player.mo.height) - (8*player.mo.scale)
	else
		z = player.mo.z + 8*player.mo.scale
	end
	
	
	mo.angle = player.mo.angle
	P_MoveOrigin(mo, player.mo.x, player.mo.y, player.mo.z + (8*player.mo.scale))
	return true
end
addHook("FollowMobj", WolfensteinCameraObj, MT_WOLFCAMERA)

local function BulletRange(mo, targ)
	if not (mo.flags & MF_MISSILE) then //not set up yet
		return false
	end

	if not (targ.flags & MF_SHOOTABLE)
	and not (targ.type == MT_SPIKE)
	and not (targ.type == MT_WALLSPIKE)
	or (targ.type == MT_PLAYER)
		return
	end

	if not (mo.knife)
		if (targ.type == MT_SPIKE)
		or (targ.type == MT_WALLSPIKE) then
			return
		end
	end

	if not (mo.hitdist)
		return
	end

	//don't hit through floors/ceilings
	if not (mo.floorrover == targ.floorrover)
	or not (mo.ceilingrover == targ.ceilingrover) then
		return
	end
	
	if (mo.knife) then
		if (targ.type == MT_SPIKE)
		or (targ.type ==MT_WALLSPIKE) then
			P_KillMobj(targ)
			P_RemoveMobj(mo)
			return true
		end
	end
	
	P_DamageMobj(targ, mo, mo.target)
	P_RemoveMobj(mo)
	return true
end
addHook("MobjMoveCollide", BulletRange, MT_WOLFBULLET)

mobjinfo[MT_WOLFBULLET] = {
	spawnstate = S_PLAY_STND,
	speed = 4*FRACUNIT,
	radius = 4*FRACUNIT,
	height = 1,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

local function BreakWalls(mo, line)
	local sect = {line.frontsector, line.backsector}
	local doStop

	for i = 1,table.maxn(sect),1
		for rover in sect[i].ffloors()
		
			if not (rover.flags & FF_EXISTS)
			or not (rover.flags & FF_BUSTUP) then
				continue
			end
			
			if (P_MobjFlip(mo)*(mo.z+mo.height) > (rover.bottomheight))
			and (P_MobjFlip(mo)*(mo.z+mo.momz) < (rover.topheight))
				EV_CrumbleChain(sect[i], rover)
			end
		end
	end
end

addHook("MobjLineCollide", BreakWalls, MT_WOLFBULLET)